//#include <GL\glut.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
//#include <vl\VLf.h>

#include "Foliage.h"


/******************************************   PANTALLA **************************************************/
//--------------------------------------------------------------------------------------------------------------------------------
// Void constructor
// Parameters --> None
//--------------------------------------------------------------------------------------------------------------------------------
Foliage::Foliage(void):  MiArbol(NULL), Acth(NULL)
{
	 ppio= final = -1;
}


//--------------------------------------------------------------------------------------------------------------------------------
// Constructor with the name of a file cotaining the data
//--------------------------------------------------------------------------------------------------------------------------------
Foliage::Foliage ( Arbol *Arbol1)
{
	int h=0;


	MiArbol = Arbol1;

	Acth  = new Activas[(MiArbol->nHojas)*8];

	for ( h=0; h < MiArbol->nHojas; h++) {

		Acth[h].indice = h;
		if ( h != 0)
		{
			Acth[h].prev = (h-1);
			Acth[h-1].next = h;
		}

	}
				
	ppio = 0;
	final = (MiArbol->nHojas)-1;
	nhactivas = MiArbol->nHojas;



}

//--------------------------------------------------------------------------------------------------------------------------------
// Destructor. We must deallocate the memory allocated for pointers to vertices and edges
//--------------------------------------------------------------------------------------------------------------------------------
Foliage::~Foliage (void)
{
	delete MiArbol;
	delete Acth;
}
//

//--------------------------------------------------------------------------------------------------------------------------------
// Dibuja una hoja
//--------------------------------------------------------------------------------------------------------------------------------
				/*
void Foliage::Dibuja_Hoja ( Hoja &aHoja)
{
	
	float a,b,c;

	glBegin (GL_TRIANGLE_STRIP);
		glNormal3fv (aHoja.Normal);
		MiArbol->Vertices[aHoja.Vert_Hoja[0]].GetCoordinates (a,b,c);
		glTexCoord2f ( 0.0, 0.0);

		glVertex3f (a,b,c);

		MiArbol->Vertices[aHoja.Vert_Hoja[1]].GetCoordinates (a,b,c);
		glTexCoord2f ( 0.0, 1.0);
		glVertex3f (a,b,c);
	
		MiArbol->Vertices[aHoja.Vert_Hoja[2]].GetCoordinates (a,b,c);
		glTexCoord2f ( 1.0, 0.0);
		glVertex3f (a,b,c);

		MiArbol->Vertices[aHoja.Vert_Hoja[3]].GetCoordinates (a,b,c);
		glTexCoord2f ( 1.0, 1.0);
		glVertex3f (a,b,c);

	glEnd ();

}


//--------------------------------------------------------------------------------------------------------------------------------
// Dibujar todas las hojas activas 
//--------------------------------------------------------------------------------------------------------------------------------
				
int Foliage::DibujarHojas (float frustum[6][4], float zoom)
{
	int hojactiva, i;


	glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);

	hojactiva = 0;
	glBindTexture (GL_TEXTURE_2D,texName[0]);
	glEnable(GL_ALPHA_TEST);

	if ( zoom <75.0) 
	//if ( false) 
	{
		//calculo el culling de las hojas de minimo detalle
		Culling (frustum);
		//printf ( "--------------------------->Entro en culling\n");

		i= ppio; 
		while ( i != -1)
		{ 
			if (MiArbol->Hojas[MiArbol->Hojas[i].raiz].visible == 1)
			{
				hojactiva ++;
				Dibuja_Hoja (MiArbol->Hojas[i]);
			}
			i = Acth[i].next;
		}
	}
	else
	{
		i= ppio; 
    	while ( i != -1)
		{ 
			hojactiva ++;
			Dibuja_Hoja (MiArbol->Hojas[i]);
			i=Acth[i].next;
		}

	}



	glDisable(GL_ALPHA_TEST);

	return ( hojactiva);

}

//--------------------------------------------------------------------------------------------------------------------------------
// Dibujar media copa del arbol 
// si el char c es 'f' dibuja la parte delantera
// si es 'b' la parte trasera
//--------------------------------------------------------------------------------------------------------------------------------
				
int Foliage::DibujaMediaCopa (  char c, float rva, float rvb,float rvc, float rvd, float radio)
{
	int hojactiva, i;
//	int count, count2;

	glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);

	hojactiva = 0;
	glBindTexture (GL_TEXTURE_2D,texName[0]);
	glEnable(GL_ALPHA_TEST);

	i= ppio; 
	if ( c == 'b')
	{//count = 0;
	while ( i != -1)
	{  //count ++;
			if ( Criterio (MiArbol->Hojas[i],'p', rva,rvb,rvc,rvd, radio) == false) //esta detras del plano
		{
			hojactiva ++;
			Dibuja_Hoja (MiArbol->Hojas[i]);
			}
		i = Acth[i].next;

	}
//	printf ( " EN LA TRASERA chequeo %i hojas \n", count);
	}
	else
	{// count2 = 0;

		while ( i != -1)
		{ //count2++;
			if ( Criterio (MiArbol->Hojas[i],'p', rva,rvb,rvc,rvd, radio) == true) //esta detras del plano
		{
			hojactiva ++;
			Dibuja_Hoja (MiArbol->Hojas[i]);
			}
		i = Acth[i].next;
	}
		//	printf ( " EN LA DELANTERA chequeo %i hojas \n", count2);

	}
	glDisable(GL_ALPHA_TEST);

//	nhactivas = hojactiva;


	return ( hojactiva);



}



//-------------------------------------------------------------------------------------------------------------------------
// dibuja la esfera
//-------------------------------------------------------------------------------------------------------------------------

void Foliage::DibujaEsfera(float r)
{

	glPushMatrix();
		glTranslated (0.0,MiArbol->cy, 0.0);
		glColor3f(1.0, 0.0, 0.0);
		glDisable(GL_LIGHTING);
		glLineWidth(1.2);
		glPolygonMode (GL_FRONT_AND_BACK, GL_LINE);
		glutSolidSphere ( r,20, 20);
		glEnable(GL_LIGHTING);
		glColor3f ( 1.0, 1.0, 1.0);
	glPopMatrix();

}

/******************************************   CULLING **************************************************/
//-------------------------------------------------------------------------------------------------------------------------
// culling de las hojas de menor detalle
//-------------------------------------------------------------------------------------------------------------------------

void Foliage::Culling (float frustum[6][4])
{
	int i, j;

	i = 0;
	while ( MiArbol->MinDet[i].indice != -1)
	{
		j = MiArbol->MinDet[i].indice;
		if (LeafinFrustum ( j, frustum) == true) {
		//	printf("dentro %i y el padre es %i\n", j, MiArbol->Hojas[MiArbol->MinDet[i].indice].padre);
			MiArbol->Hojas[j].visible = 1;
		}
		else  
		{
		//	printf("fuera %i\n", j);
			MiArbol->Hojas[j].visible = 0;
		}

		i++;
	}

}


//-------
// si est en el frustrum --> true
//	sino --> false
//------------


bool Foliage::LeafinFrustum ( int i, float frustum[6][4])
{
	float a,b,c, tmp,rad;
	int j,p;
	Vector v;

	for (j =0; j<4; j++)
	{
//		MiArbol->Vertices[MiArbol->Hojas[i].Vert_Hoja[j]].GetCoordinates (a,b,c);
		MiArbol->vertexdata->GetVertexCoord(MiArbol->Hojas[i].Vert_Hoja[j],a,b,c);
		v[0]=a; v[1]=b;	v[2]=c; v[3]=1;

		//  el punto resultante ser
		v = mat_aux*v;

		for( p = 0; p < 5; p++ )
		{ tmp = frustum[p][0] * v[0] + frustum[p][1] * v[1] + frustum[p][2] * v[2] + frustum[p][3];
		  if ( tmp <= -2.0 )  return false;
		}
	}


	return true;

}


/******************************************   CRITERIO **************************************************/



//---------------------------------------------------------------------------------------------------------
// es activo?
//---------------------------------------------------------------------------------------------------------

bool Foliage::EsActivo (  int num)
{
	return ( (Acth[num].prev != -1) || (Acth[num].next != -1));
}




//-------
// si est delante devolver 1. Si est detrs -1
//------------

int Foliage::DondeEsta (  float x, float y, float z, float rva, float rvb,float rvc, float rvd)
{
	// el plano sera pa x + pb y + pc z + pd = 0
	float donde;
	int   esta;

	donde = (rva * x) + (rvb * y) + (rvc * z) + rvd;
	
	if ( donde <0) esta = -1;  //delante
	 else if ( donde > 0) esta =1; //detrs
			else esta = 0;

			return esta;

}



//----------------------------
// EXPLICACION DE LOS PARAMETROS::
// ch --> criterio a aplicar:
//			si es p --> plano
//			si es d --> plano y esfera
//			si es e --> esfera
//DEVUELVE true cuando est en la zona de interes y debe estar a maximo detalle
//----------------------------


bool Foliage::Criterio ( Hoja &aHoja,  char ch, float rva, float rvb,float rvc, float rvd, float radio)
{
	float a,b,c; // coordenadas del primero de los vertices en la hoja
	float d,e,f; // coords vertice 2
	float g,h,i; // coords vertice 3
	float j,k,l; // coords vertice 4
	float dist;
	bool inter=false, inter2=false;
	float ccx, ccy, ccz;

	

//	MiArbol->Vertices[aHoja.Vert_Hoja[0]].GetCoordinates (a,b,c);
	MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[0],a,b,c);

	ccx = MiArbol->cx;
	ccy = MiArbol->cy;
	ccz = MiArbol->cz;


	if ( (ch == 'p') || (ch == 'd'))
	{
	//plano siempre 
	if (DondeEsta (a,b,c, rva,rvb,rvc,rvd) == 1)
	{
//		MiArbol->Vertices[aHoja.Vert_Hoja[1]].GetCoordinates (d,e,f);
		MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[1],d,e,f);
		if (DondeEsta (d,e,f, rva,rvb,rvc,rvd) == 1)
		{
//			MiArbol->Vertices[aHoja.Vert_Hoja[2]].GetCoordinates (g,h,i);
			MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[2],g,h,i);
			if (DondeEsta (g,h,i, rva,rvb,rvc,rvd) == 1)
			{
//				MiArbol->Vertices[aHoja.Vert_Hoja[3]].GetCoordinates (j,k,l);
				MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[3],j,k,l);
				if (DondeEsta (j,k,l, rva,rvb,rvc,rvd) == 1) inter = true;
			}
		}

	}
	

	}
	
		
	if (( ch == 'e') || (( ch == 'd') && (inter == true))) //CRITERIO DE LA ESFERA
	{
	
	dist =(float)sqrt ((a-ccx)*(a-ccx)+ (b-ccy)*(b-ccy)+ (c-ccz)*(c-ccz));
	if (dist >  radio)

	{
//		MiArbol->Vertices[aHoja.Vert_Hoja[1]].GetCoordinates (a,b,c);
		MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[1],a,b,c);
		dist =(float)sqrt ((a-ccx)*(a-ccx)+ (b-ccy)*(b-ccy)+ (c-ccz)*(c-ccz));

		if (dist >  radio)
		{
//			MiArbol->Vertices[aHoja.Vert_Hoja[2]].GetCoordinates (a,b,c);
			MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[2],a,b,c);
			dist =(float)sqrt ((a-ccx)*(a-ccx)+ (b-ccy)*(b-ccy)+ (c-ccz)*(c-ccz));

			if (dist >  radio)
			{
//				MiArbol->Vertices[aHoja.Vert_Hoja[3]].GetCoordinates (a,b,c);
				MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[3],a,b,c);
				dist =(float)sqrt ((a-ccx)*(a-ccx)+ (b-ccy)*(b-ccy)+ (c-ccz)*(c-ccz));

				if (dist >  radio) inter2 = true;
			}
		}
	}
		inter =  inter2;
	}


	return inter;
}





/******************************************   RESOLUCIN VARIABLE **************************************************/

//-----------------------------------------
//
//	RECORDAR!!!
//		NO cumple el criterio ------------>  POCO  DETALLE ( COLAPSAR )
//		SI cumple el criterio ------------>  MUCHO DETALLE ( SPLITEAR )
//
// el ch se le pasa a Criterio y es all donde se evalua
//	    e --> esfera
//      p --> plano
//      d --> los dos criterios
//------------------------------------------

int Foliage::ResolucionV (char ch, float rva, float rvb,float rvc, float rvd, float radio)
{
	bool lista=false;
    int i, hpost, spli;
	float renvol, centroz;
	
	i = ppio;
	spli = -1;

	renvol = MiArbol->rad;
	centroz = MiArbol->cz;
//	printf (" el centro en %f y el radio es de %f\n", centroz, renvol);

// fijo el mximo del plano de RV

	if (rvd < centroz -renvol )
		  rvd = (centroz -renvol );
	else if (rvd > centroz +renvol )
		  rvd = (centroz +renvol );

//	printf (" el plano est en %f\n", rvd);


	//para que fije el valor mximo del radio

	if  (( ch == 'e') || ( ch == 'd')) 
	{	if (radio> renvol)	radio = renvol;
		else if (radio <0)  radio =0.0;
	}

//	printf (" el radio vale %f\n", radio);
	
	//empieza a buscar las hojas activas

	while ( i != -1){
		
		hpost = Acth[i].next;

		//COLAPSAR

		if (( Criterio ( MiArbol->Hojas[i], ch, rva,rvb,rvc,rvd, radio )== false) && (MiArbol->Hojas[i].padre != -1)) 
		{
			// SI ESTA FUESE LA HOJA IZQUIERDA Y LA DERECHA NO CUMPLE TAMPOCO EL CRITERIO
			if ((MiArbol->Hojas[MiArbol->Hojas[i].padre].hijoi == i) &&
				( Criterio (MiArbol->Hojas[MiArbol->Hojas[MiArbol->Hojas[i].padre].hijod] , ch, rva,rvb,rvc,rvd, radio )== false))
			{	//hay que colapsar
				if (EsActivo(MiArbol->Hojas[MiArbol->Hojas[i].padre].hijod) == false)
					lista = Forzar_Colapse (MiArbol->Hojas[MiArbol->Hojas[i].padre].hijod, hpost, ch, rva,rvb,rvc,rvd, radio); // para activarla
				else lista = true;
									
			}
			else
			// SI ESTA FUESE LA HOJA DERECHA Y LA IZQUIERDA NO CUMPLE TAMPOCO EL CRITERIO
			if ((MiArbol->Hojas[MiArbol->Hojas[i].padre].hijod == i) &&
				( Criterio (MiArbol->Hojas[MiArbol->Hojas[MiArbol->Hojas[i].padre].hijoi] , ch, rva,rvb,rvc,rvd, radio )== false))
			{//hay que colapsar
				if (EsActivo(MiArbol->Hojas[MiArbol->Hojas[i].padre].hijoi) == false)
					 lista = Forzar_Colapse (MiArbol->Hojas[MiArbol->Hojas[i].padre].hijoi, hpost,  ch, rva,rvb,rvc,rvd, radio); // para activarla
				else  lista = true;
					
			}
			
			 //estan activas preparadas para subir un nivel en la zona de no detalle.
			
			if ( lista == true)
			{
				lista = false;
				
					ColapsaHoja ( MiArbol->Hojas[i].padre, hpost);
			}
					
		}
    	i = hpost;

	}
	
	//ahora veo lo de splitear
	i = ppio;
	spli = -1;

	while ( i != -1){
		hpost = Acth[i].next;
		spli = Chequea_Split (i, ch, rva,rvb,rvc,rvd, radio);
			if ( spli != -1) 
				{	Forzar_Split ( spli, i, hpost);
					spli = -1;
				}
			i = hpost;
	}

	return (1);
		
}

//--------------------------------------------------------------------------------------------------------------------------------
// Colapsa dos hojas 
//--------------------------------------------------------------------------------------------------------------------------------
				
void Foliage::ColapsaHoja (  int h,   int& post)
{

	//actualizo los punteros del ppio y del final, y post
	while (( ppio == MiArbol->Hojas[h].hijoi) || ( ppio == MiArbol->Hojas[h].hijod))
		ppio = Acth[ppio].next;
	while (( final == MiArbol->Hojas[h].hijoi) || ( final == MiArbol->Hojas[h].hijod))
		 final = Acth[final].prev; 

	while (( post == MiArbol->Hojas[h].hijoi) || ( post == MiArbol->Hojas[h].hijod))
		 post = Acth[post].next; 



	//COLAPSAR = QUITO DOS DE ACTIVOS PONGO UNO A ACTIVO

	if (Acth[MiArbol->Hojas[h].hijoi].next != -1)
		Acth[Acth[MiArbol->Hojas[h].hijoi].next].prev = Acth[MiArbol->Hojas[h].hijoi].prev;
	if (Acth[MiArbol->Hojas[h].hijoi].prev != -1)
		Acth[Acth[MiArbol->Hojas[h].hijoi].prev].next = Acth[MiArbol->Hojas[h].hijoi].next;

	if (Acth[MiArbol->Hojas[h].hijod].next != -1)
		Acth[Acth[MiArbol->Hojas[h].hijod].next].prev = Acth[MiArbol->Hojas[h].hijod].prev;
	if (Acth[MiArbol->Hojas[h].hijod].prev != -1)
		Acth[Acth[MiArbol->Hojas[h].hijod].prev].next = Acth[MiArbol->Hojas[h].hijod].next;

	
	//  desconecto a los hijos
	Acth[MiArbol->Hojas[h].hijoi].prev = -1;
	Acth[MiArbol->Hojas[h].hijoi].next = -1;
	Acth[MiArbol->Hojas[h].hijod].prev = -1;
	Acth[MiArbol->Hojas[h].hijod].next = -1;

	//aado al final
	Acth[h].prev = final;
	Acth[h].next = -1;
	Acth[final].next = h;
	final = h;

	
}




//--------------------------------------------------------------------------------------------------
// Forzar colapse 
// la hoja que paso en el parametro hoja es la que quiero que se active al final
//--------------------------------------------------------------------------------------------------


bool Foliage::Forzar_Colapse(int hoja,  int &hpost,  char ch, float rva, float rvb,float rvc, float rvd, float radio)
{
	
	int h;
	lista <int> listah;
	bool fin;

	fin = false;
	listah.Inserta (hoja); // Inserta un dato en la lista

	while  (listah.NDatos () != 0) 
	{
		
		h = listah.GetCola ();//coger la cola
		if (MiArbol->Hojas[h].hijoi != -1) 

		{ if (!EsActivo (MiArbol->Hojas[h].hijoi ))
			listah.Inserta (MiArbol->Hojas[h].hijoi);
			
		  if ( (!EsActivo (MiArbol->Hojas[h].hijod)) )	
			listah.Inserta (MiArbol->Hojas[h].hijod);
		
		  if (EsActivo (MiArbol->Hojas[h].hijoi) && EsActivo (MiArbol->Hojas[h].hijod )) 
			  if((Criterio ( MiArbol->Hojas[MiArbol->Hojas[h].hijoi] ,ch, rva,rvb,rvc,rvd, radio )== false) &&
				  (Criterio ( MiArbol->Hojas[MiArbol->Hojas[h].hijod], ch, rva,rvb,rvc,rvd, radio ) == false))
			{
		    	ColapsaHoja ( h, hpost);
				listah.Borra(h);
			}
			  else fin = true;
		}
		else
		{  fin = true;
		   listah.Borra(h);
		}

		if ( fin == true )
			while ( listah.NDatos () != 0)
				listah.BorraCola();
	
	}

	return (EsActivo (hoja));
		
}


//--------------------------------------------------------------------------------------------------------------------------------
// Splitea una hoja 
//--------------------------------------------------------------------------------------------------------------------------------
				
void Foliage::SplitHoja (int h, int &post)
{

	// SPLITEAR: QUITO UNO, PONGO DOS
	
	if ( ppio == h) ppio = Acth[h].next;
	if ( final == h) final = Acth[h].prev; 

	// 1 enlazo los hijos 
	Acth[MiArbol->Hojas[h].hijoi].next = MiArbol->Hojas[h].hijod;
	Acth[MiArbol->Hojas[h].hijod].prev = MiArbol->Hojas[h].hijoi;
	Acth[MiArbol->Hojas[h].hijod].next = -1;

	//y desconecto al padre
	if ( Acth[h].prev != -1)
		Acth[Acth[h].prev].next = Acth[h].next;
	if ( Acth[h].next != -1)
		Acth[Acth[h].next].prev = Acth[h].prev;
	Acth[h].prev = -1;
	Acth[h].next = -1;
	
	//aado al final los hijos 
	Acth[MiArbol->Hojas[h].hijoi].prev = final;
	Acth[final].next = MiArbol->Hojas[h].hijoi;
	final = MiArbol->Hojas[h].hijod;

}




//-------------------------------------------------------------------------------------------
// chequear si tengo que splitear. Devuelve el primero de los nodos que cumple la condicion
//-------------------------------------------------------------------------------------------

int Foliage::Chequea_Split(int h,  char ch, float rva, float rvb,float rvc, float rvd, float radio)
{
	
	int  nodo;
	

	nodo = -1;

	if (MiArbol->Hojas[h].hijoi != -1) 

	{  // si el hijo derecho o el izquierdo estn en la zona de mximo detalle, har que estos se activen 	
		  if ( (Criterio (MiArbol->Hojas[MiArbol->Hojas[h].hijoi],  ch, rva,rvb,rvc,rvd, radio ) == true) ||
			  (Criterio (MiArbol->Hojas[MiArbol->Hojas[h].hijod], ch, rva,rvb,rvc,rvd, radio ) == true))
			
				nodo = MiArbol->Hojas[h].hijoi; 
			
			else // si no, bajo un nivel ms hasta encontrar algn descendiente que se encuentre en la zona de + detalle
			{
				nodo = Chequea_Split (MiArbol->Hojas[h].hijoi,  ch, rva,rvb,rvc,rvd, radio);
				if ( nodo == -1 ) nodo = Chequea_Split (MiArbol->Hojas[h].hijod, ch, rva,rvb,rvc,rvd, radio);
			}
				  
		}
		
	return (nodo);
		
}

//-------------------------------------------------------------------------------------------
// fuerzo a splitear
// hoja -> es el nodo que cumple la condicion
// padre -> es el nodo que chequeaba de la lista de activos
// hpost -> es el nodo siguiente en la lista de activos
//-------------------------------------------------------------------------------------------

bool Foliage::Forzar_Split(int hoja, int padre, int &hpost)
{
	
	int h;
	lista <int> listah;
	bool bien;

	bien = false;
	h = MiArbol->Hojas[hoja].padre;
	listah.Inserta (h); // Inserta un dato en la lista

	while ( h != padre)
	{
		h = MiArbol->Hojas[h].padre;
		listah.Inserta (h); // Inserta un dato en la lista
	}


	while  (listah.NDatos () != 0) 
	{
		h = listah.GetCola ();//coger el padre ms alto
		SplitHoja(h, hpost);
		listah.Borra(h);
	
	}

	if ( listah.NDatos() == 0)
		bien = true;
	return (bien);
		
}		




/******************************************   RESOLUCIN CONSTANTE **************************************************/


int Foliage::ResolucionC (float dist, float dmax, float dmin)
{

	float difdist,  d;
	int difhojas, nhojas;

	if (( dist > dmin) && (dist <dmax))
	{
		difdist = dmax - dmin;
		difhojas = MiArbol->nHojas - MiArbol->minHojas;

		d = dist - dmin;

		//regla de 3

		nhojas = abs(d*difhojas /difdist);

		AjusteHojas ((MiArbol->nHojas)-nhojas);

	}
	else if (dist > dmax) {
		AjusteHojas (MiArbol->minHojas);
	}
	else if (dist < dmin) {
		AjusteHojas (MiArbol->nHojas);
	}
		
	return (nhactivas);
}



void Foliage::AjusteHojas( int nhojas)
{
	if ((nhojas <= MiArbol->nHojas) && (nhojas >= MiArbol->minHojas))
	{
		if ( nhojas < nhactivas) {
			RCecol ( nhactivas - nhojas);
		}
		else  {
			 RCsplit (nhojas-nhactivas );
		}

		nhactivas = nhojas;
	//	printf ( "ajusto a %i\n", nhactivas );

	}

}

//-----------------------------------------
//
//	RECORDAR!!!
//		NO cumple el criterio ------------>  POCO  DETALLE ( COLAPSAR )
//		SI cumple el criterio ------------>  MUCHO DETALLE ( SPLITEAR )
//
// el ch se le pasa a Criterio y es all donde se evalua
//------------------------------------------

/*
void Foliage::RCecol (  int nhojas)
{
	int i, hpost;

	i = ppio;
	
	while (( i != -1) && (nhojas>0)){
 		hpost = Acth[i].next;

			if ( MiArbol->Hojas[i].padre != -1) 
				if ( MiArbol->Hojas[MiArbol->Hojas[i].padre].hijoi == i)
				{if ( EsActivo (MiArbol->Hojas[MiArbol->Hojas[i].padre].hijod ) )
				{ 
					ColapsaHoja ( MiArbol->Hojas[i].padre, hpost);
					nhojas --; }
				}
				else 
				{if ( EsActivo (MiArbol->Hojas[MiArbol->Hojas[i].padre].hijoi ) )
				{
					ColapsaHoja ( MiArbol->Hojas[i].padre, hpost); 
					nhojas --; }
				}


		i = hpost;
		
	}
}
*/

void Foliage::RCecol ( int num)
{

	int  j, h;

	j = num;
	h = final+1;
		while ((h<=MiArbol->TotHojas) && (j>0))
		{
			while (( ppio == MiArbol->Hojas[h].hijoi) || ( ppio == MiArbol->Hojas[h].hijod))
				ppio = Acth[ppio].next;

			while (( final == MiArbol->Hojas[h].hijoi) || ( final == MiArbol->Hojas[h].hijod))
				final = Acth[final].prev; 


			//COLAPSAR = QUITO DOS DE ACTIVOS PONGO UNO A ACTIVO

			if (Acth[MiArbol->Hojas[h].hijoi].next != -1)
				Acth[Acth[MiArbol->Hojas[h].hijoi].next].prev = Acth[MiArbol->Hojas[h].hijoi].prev;
			if (Acth[MiArbol->Hojas[h].hijoi].prev != -1)
				Acth[Acth[MiArbol->Hojas[h].hijoi].prev].next = Acth[MiArbol->Hojas[h].hijoi].next;

			if (Acth[MiArbol->Hojas[h].hijod].next != -1)
				Acth[Acth[MiArbol->Hojas[h].hijod].next].prev = Acth[MiArbol->Hojas[h].hijod].prev;
			if (Acth[MiArbol->Hojas[h].hijod].prev != -1)
				Acth[Acth[MiArbol->Hojas[h].hijod].prev].next = Acth[MiArbol->Hojas[h].hijod].next;

	
			//  desconecto a los hijos
			Acth[MiArbol->Hojas[h].hijoi].prev = -1;
			Acth[MiArbol->Hojas[h].hijoi].next = -1;
			Acth[MiArbol->Hojas[h].hijod].prev = -1;
			Acth[MiArbol->Hojas[h].hijod].next = -1;

			//aado al final
			Acth[h].prev = final;
			Acth[h].next = -1;
			Acth[final].next = h;
			final = h;


			// decremento el contador de colapsos
			j--;
			//incremento el posible siguiente colapso 
			h++;


		}

}

/*
void Foliage::RCsplit (  int nhojas)
{
	int i, hpost;

	i = ppio;
	
	while (( i != -1) && (nhojas>0)){
		hpost = Acth[i].next;

		if (MiArbol->Hojas[i].hijoi != -1){
					SplitHoja(i, hpost);
					nhojas --;

		}
		
		i = hpost;

	}
}
*/

int Foliage::AnteriorActivo (int h)
{
	int i;

	
	if (ppio > h)  i = -1;
	else
	{
		i = h--;
	
		while (EsActivo (i) == false) 	
			i--;
	}

	return (i);
}

int Foliage::PosteriorActivo (int h)
{	int i;

	i = h++;
	
	while ((EsActivo (i) == false) || (i> MiArbol->TotHojas))
		i++;

	if (i > MiArbol->TotHojas) i=-1;


	return (i);
}

void Foliage::RCsplit ( int num)
{

	int  j, h, ant, post;

	j = num;
	h = final;
	while ((h > MiArbol->nHojas) &&  (j>0))
	{

		///////////// insertar a los hijos en orden segun su indice
		//hijo izquierdo
		ant = AnteriorActivo (MiArbol->Hojas[h].hijoi);
		post = PosteriorActivo (MiArbol->Hojas[h].hijoi);


		Acth[MiArbol->Hojas[h].hijoi].next = post;
		Acth[MiArbol->Hojas[h].hijoi].prev = ant;
		if (ant != -1) Acth[ant].next = MiArbol->Hojas[h].hijoi;
			else ppio = MiArbol->Hojas[h].hijoi;
		if (post != -1) Acth[post].prev = MiArbol->Hojas[h].hijoi;

		
		//hijo derecho
		ant = AnteriorActivo (MiArbol->Hojas[h].hijod);
		post = PosteriorActivo (MiArbol->Hojas[h].hijod);


		Acth[MiArbol->Hojas[h].hijod].next = post;
		Acth[MiArbol->Hojas[h].hijod].prev = ant;
		if (ant != -1)  Acth[ant].next = MiArbol->Hojas[h].hijod;
				else ppio = MiArbol->Hojas[h].hijod;
		if (post != -1) Acth[post].prev = MiArbol->Hojas[h].hijod;


		// despues de insertar los hijos miro a ver cual spliteare el siguiente
		final = Acth[h].prev;
		
		//y desconecto al padre
		if ( Acth[h].prev != -1)
			Acth[Acth[h].prev].next = Acth[h].next;
		//if ( Acth[h].next != -1)
		//	Acth[Acth[h].next].prev = Acth[h].prev;
		Acth[h].prev = -1;
		Acth[h].next = -1;
	
		// decremento el contador de colapsos
		j--;
		//incremento el posible siguiente colapso 
		h--;


	}


 }
